# Coverage for Doctrine_Hook_Integer

Back to coverage report

1 | <?php
2 | /*
3 | * $Id: Integer.php 2702 2007-10-03 21:43:22Z Jonathan.Wage $
4 | *
5 | * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
6 | * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
7 | * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
8 | * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
9 | * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
10 | * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
11 | * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
12 | * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
13 | * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
14 | * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
15 | * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
16 | *
17 | * This software consists of voluntary contributions made by many individuals
18 | * and is licensed under the LGPL. For more information, see
19 | * <http://www.phpdoctrine.org>.
20 | */
21 | Doctrine::autoload('Doctrine_Hook_Parser_Complex');
22 | /**
23 | * Doctrine_Hook_Integer
24 | *
25 | * @package Doctrine
26 | * @subpackage Hook
27 | * @license http://www.opensource.org/licenses/lgpl-license.php LGPL
28 | * @link www.phpdoctrine.org
29 | * @since 1.0
30 | * @version $Revision: 2702 $
31 | * @author Konsta Vesterinen <kvesteri@cc.hut.fi>
32 | */
33 | class Doctrine_Hook_Integer extends Doctrine_Hook_Parser_Complex
34 | {
35 | /**
36 | * parse
37 | * Parses given field and field value to DQL condition
38 | * and parameters. This method should always return
39 | * prepared statement conditions (conditions that use
40 | * placeholders instead of literal values).
41 | *
42 | * @param string $alias component alias
43 | * @param string $field the field name
44 | * @param mixed $value the value of the field
45 | * @return void
46 | */
47 | public function parseSingle($alias, $field, $value)
48 | {
49 | $e = explode(' ', $value);
50 |
51 | foreach ($e as $v) {
52 | $v = trim($v);
53 |
54 | $e2 = explode('-', $v);
55 |
56 | $name = $alias. '.' . $field;
57 |
58 | if (count($e2) == 1) {
59 | // one '-' found
60 |
61 | $a[] = $name . ' = ?';
62 |
63 | $this->params[] = $v;
64 | } else {
65 | // more than one '-' found
66 |
67 | $a[] = '(' . $name . ' > ? AND ' . $name . ' < ?)';
68 |
69 | $this->params += array($e2[0], $e2[1]);
70 | }
71 |
72 | }
73 | return implode(' OR ', $a);
74 | }
75 | }